-------------------------------------------------------
-- decode 10sin
-- 2007/1/1
-------------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;

entity decode10sin is
	port(
		a		:in std_logic;
		b		:in std_logic;
		c		:in std_logic;
		d		:in std_logic;
		d0		:out std_logic;
		d1		:out std_logic;
		d2		:out std_logic;
		d3		:out std_logic;
		d4		:out std_logic;
		d5		:out std_logic;
		d6		:out std_logic;
		d7		:out std_logic;
		d8		:out std_logic;
		d9		:out std_logic
		);
end decode10sin;

architecture rtl of decode10sin is
	signal input_table	:std_logic_vector(3 downto 0);
	signal output_table	:std_logic_vector(9 downto 0);
	
begin
	input_table <= d & c & b & a;
	with input_table select
		output_table <= "0000000001" when "0000",	-- 0
						"0000000010" when "0001",	-- 1
						"0000000100" when "0010",	-- 2
						"0000001000" when "0011",	-- 3
						"0000010000" when "0100",	-- 4
						"0000100000" when "0101",	-- 5
						"0001000000" when "0110",	-- 6
						"0010000000" when "0111",	-- 7
						"0100000000" when "1000",	-- 8
						"1000000000" when "1001",	-- 9
						"0000000000" when others;
						
	d0 <= output_table(0);
	d1 <= output_table(1);
	d2 <= output_table(2);
	d3 <= output_table(3);
	d4 <= output_table(4);
	d5 <= output_table(5);
	d6 <= output_table(6);
	d7 <= output_table(7);
	d8 <= output_table(8);
	d9 <= output_table(9);
	
end rtl;	
		