-------------------------------------------------------
-- decode 6sin not
-- 2007/2/24
-------------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;

entity decode6sinnot is
	port(
		a		:in std_logic;
		b		:in std_logic;
		c		:in std_logic;
		d		:in std_logic;
		d0		:out std_logic;
		d1		:out std_logic;
		d2		:out std_logic;
		d3		:out std_logic;
		d4		:out std_logic;
		d5		:out std_logic
		);
end decode6sinnot;

architecture rtl of decode6sinnot is
	signal input_table	:std_logic_vector(3 downto 0);
	signal output_table	:std_logic_vector(5 downto 0);
	
begin
	input_table <= d & c & b & a;
	with input_table select
		output_table <= "111110" when "0000",	-- 0
						"111101" when "0001",	-- 1
						"111011" when "0010",	-- 2
						"110111" when "0011",	-- 3
						"101111" when "0100",	-- 4
						"011111" when "0101",	-- 5
						"111111" when others;
						
	d0 <= output_table(0);
	d1 <= output_table(1);
	d2 <= output_table(2);
	d3 <= output_table(3);
	d4 <= output_table(4);
	d5 <= output_table(5);

end rtl;	
		